//+------------------------------------------------------------------+
//|                                                     cmdfibos.mq4 |
//|                                         Copyright  2009, Camper |
//|                                        http://www.aboutcamper.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Camper"
#property link      "http://www.aboutcamper.ru"

//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
// #define MacrosHello   "Hello, world!"
// #define MacrosYear    2005

//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
// #import "user32.dll"
//   int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);

// #import "my_expert.dll"
//   int      ExpertRecalculate(int wParam,int lParam);
// #import

//+------------------------------------------------------------------+
//| EX4 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex4"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+

double fiboLevel[]={1.0,1.61,2.61,3.61};	//  ,   
double fiboSecondLevel=0.236;					//        
color fiboColor=Aqua;

void drawFibo(int fromBar, int toBar, double zeroPrice, double fullPrice){
	string name="cmd_fibo_"+fromBar;
	//   
	ObjectDelete(name);
	
	//Print("Drawing Fibo from "+zeroPrice+" to "+fullPrice);
	ObjectCreate(name,OBJ_FIBO,0,iTime(NULL,0,fromBar),fullPrice,iTime(NULL,0,toBar),zeroPrice);
	ObjectSet(name,OBJPROP_LEVELCOLOR,fiboColor);
	ObjectSet(name,OBJPROP_COLOR,Black);
	ObjectSet(name,OBJPROP_STYLE,STYLE_DOT);
	ObjectSet(name,OBJPROP_LEVELSTYLE,STYLE_DOT);
	ObjectSet(name,OBJPROP_BACK,true);
	ObjectSet(name,OBJPROP_FIBOLEVELS,ArraySize(fiboLevel)+2);
	ObjectSet(name,OBJPROP_RAY,false);

	ObjectSet(name,OBJPROP_FIRSTLEVEL+0,0);
	//ObjectSetFiboDescription(name, 0, ""+toBar+"  "+"0.0 "+DoubleToStr(zeroPrice, Digits)); 
	ObjectSet(name,OBJPROP_FIRSTLEVEL+1,fiboSecondLevel);
	//ObjectSetFiboDescription(name, 1, ""+toBar+"  "+DoubleToStr(fiboSecondLevel,2)+" "+DoubleToStr((fullPrice-zeroPrice)*fiboSecondLevel+zeroPrice, Digits)); 

	for (int f=0;f<ArraySize(fiboLevel);f++){
   	ObjectSet(name,OBJPROP_FIRSTLEVEL+f+2,fiboLevel[f]);
   	//ObjectSetFiboDescription(name, f+2, ""+toBar+"  "+DoubleToStr(fiboLevel[f],2)+" "+DoubleToStr((fullPrice-zeroPrice)*fiboLevel[f]+zeroPrice, Digits)); 
  	}
  	return(0);
}

