//+------------------------------------------------------------------+
//|                                                   indicators.mq4 |
//|                                         Copyright  2009, Camper |
//|                                        http://www.aboutcamper.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Camper"
#property link      "http://www.aboutcamper.ru"

//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
// #define MacrosHello   "Hello, world!"
// #define MacrosYear    2005

//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
// #import "user32.dll"
//   int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);

// #import "my_expert.dll"
//   int      ExpertRecalculate(int wParam,int lParam);
// #import

//+------------------------------------------------------------------+
//| EX4 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex4"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+
void calculateZZ(int tf, double& zz[], double& zzL[], double& zzH[], int ExtDepth, int calculateLevel=2, int counted_bars=0){
   int i,shift,pos,lasthighpos,lastlowpos,curhighpos,curlowpos,_bars;
   double curlow,curhigh,lasthigh,lastlow;
   double min, max;
  	_bars=iBars(NULL,tf);
   if (counted_bars==0)
      {
      ArrayInitialize(zz,0.0);
      ArrayInitialize(zzL,0.0);
      ArrayInitialize(zzH,0.0);
   	
      lasthighpos=_bars; lastlowpos=_bars;
      lastlow=iLow(NULL,tf,_bars);lasthigh=iHigh(NULL,tf,_bars);
      //Print("limit=",Bars-ExtDepth);
      for(shift=_bars-ExtDepth; shift>=0; shift--)
         {
         curlowpos=iLowest(NULL,tf,MODE_LOW,ExtDepth,shift);
         curlow=iLow(NULL,tf,curlowpos);
         curhighpos=iHighest(NULL,tf,MODE_HIGH,ExtDepth,shift);
         curhigh=iHigh(NULL,tf,curhighpos);
         //------------------------------------------------
         if( curlow>=lastlow ) { lastlow=curlow; }
         else
            { 
            // 
            if( lasthighpos>curlowpos  ) 
               { 
               zzL[curlowpos]=curlow;
               ///*
               min=100000; pos=lasthighpos;
               for(i=lasthighpos; i>=curlowpos; i--)
                  { 
                    if (zzL[i]==0.0) continue;
                    if (zzL[i]<min) { min=zzL[i]; pos=i; }
                    zz[i]=0.0;
                  } 
               zz[pos]=min;
               //*/
               } 
            lastlowpos=curlowpos;
            lastlow=curlow; 
            }
         //--- high
         if( curhigh<=lasthigh )  { lasthigh=curhigh;}
         else
            {  
            //  
            if( lastlowpos>curhighpos ) 
               {  
               zzH[curhighpos]=curhigh;
               ///*
                  max=-100000; pos=lastlowpos;
                  for(i=lastlowpos; i>=curhighpos; i--)
                     { 
                       if (zzH[i]==0.0) continue;
                       if (zzH[i]>max) { max=zzH[i]; pos=i; }
                       zz[i]=0.0;
                     } 
                  zz[pos]=max;
               //*/     
               }  
            lasthighpos=curhighpos;
            lasthigh=curhigh;    
            }       
         zz[0]=iClose(NULL,tf,0);
         }
       //----------------------------------------------------------------------
      }
   else
      {
      int pos2;
      i=0;
      while (pos2<calculateLevel && i<_bars-1)
         {
         if (zz[i]!=0 && (zzH[i]!=0||zzL[i]!=0)) pos2++;
         i++;
         }
      pos2=i-1;    
      for (i=pos2-1;i>=0;i--)
         {
         zzH[i]=0;
         zzL[i]=0;
         zz[i]=0;   
         }
      if (zzH[pos2]!=0) 
         {
         lasthighpos=pos2;
         lasthigh=iHigh(NULL,tf,pos2);
         lastlowpos=Lowest(NULL,tf,MODE_LOW,ExtDepth,pos2);
         lastlow=iLow(NULL,tf,lastlowpos);
         }
      else
         {         
         lastlowpos=pos2;
         lastlow=iLow(NULL,tf,pos2);
         lasthighpos=Highest(NULL,tf,MODE_HIGH,ExtDepth,pos2);
         lasthigh=iHigh(NULL,tf,lasthighpos);
         }
      //-------------------------     
      //Print("limit=",pos2-1);
      for(shift=pos2-1; shift>=0; shift--)
         {
         curlowpos=Lowest(NULL,tf,MODE_LOW,ExtDepth,shift);
         curlow=iLow(NULL,tf,curlowpos);
         curhighpos=Highest(NULL,tf,MODE_HIGH,ExtDepth,shift);
         curhigh=iHigh(NULL,tf,curhighpos);
         //------------------------------------------------
         if( curlow>=lastlow ) { lastlow=curlow; }
         else
            { 
            // 
            if( lasthighpos>curlowpos  ) 
               { 
               zzL[curlowpos]=curlow;
               ///*
               min=100000; pos=lasthighpos;
               for(i=lasthighpos; i>=curlowpos; i--)
                  { 
                    if (zzL[i]==0.0) continue;
                    if (zzL[i]<min) { min=zzL[i]; pos=i; }
                    zz[i]=0.0;
                  } 
               zz[pos]=min;
               //*/
               } 
            lastlowpos=curlowpos;
            lastlow=curlow; 
            }
         //--- high
         if( curhigh<=lasthigh )  { lasthigh=curhigh;}
         else
            {  
            //  
            if( lastlowpos>curhighpos ) 
               {  
               zzH[curhighpos]=curhigh;
               ///*
                  max=-100000; pos=lastlowpos;
                  for(i=lastlowpos; i>=curhighpos; i--)
                     { 
                       if (zzH[i]==0.0) continue;
                       if (zzH[i]>max) { max=zzH[i]; pos=i; }
                       zz[i]=0.0;
                     } 
                  zz[pos]=max;
               //*/     
               }  
            lasthighpos=curhighpos;
            lasthigh=curhigh;    
            }       

         }
      //-------------------------           
      zz[0]=iClose(NULL,tf,0);   
      }
}
void calculateAngleMA(int tf, double& result[], int maPeriod, int maMethod, int maPrice, int counted_bars=0){
  int limit,i;
  double MA,MA1,MA2,MA3;
  double delta,delta1,delta2;
  double Line;
//----
  
  //----    
   if(counted_bars<0) return(-1);
   
   //----     
   if(counted_bars>0) counted_bars--;
   limit=iBars(NULL,tf)-counted_bars;
   if(limit>iBars(NULL,tf)-maPeriod) 
     {
     limit=iBars(NULL,tf)-maPeriod-3;
     result[iBars(NULL,tf)-maPeriod]=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,iBars(NULL,tf)-maPeriod);
     result[iBars(NULL,tf)-maPeriod-1]=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,iBars(NULL,tf)-maPeriod-1);
     result[iBars(NULL,tf)-maPeriod-2]=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,iBars(NULL,tf)-maPeriod-2);
     }
   
   for(i=limit;i>=0;i--)
     {
     MA=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,i);
     MA1=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,i+1);
     MA2=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,i+2);
     //MA3=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,i+3);
     
     delta=MA-MA1;
     delta1=MA1-MA2;
     //delta2=MA2-MA3;
     
     //   (  ) -    
     if((delta>0 && delta1<=0) || (delta<0 && delta1>=0))
       {
       result[i]=MA;
       result[i+1]=MA1;  //    ( 1- ) !!!!!
       continue;
       }
     
     //     
     Line=2*result[i+1]-result[i+2];
     //Line=2*MA1-MA2;
     
     //   
     if(delta>=0)
       {
       if(MA>Line) result[i]=MA;  //   
        else 
         {
         //  2      
         if(result[i+2]<MA2) result[i]=MA;  //   
          else result[i]=2.*result[i+1]-result[i+2];  //    
         
         }
       
       //   
       if(iClose(NULL,tf,i+1)<result[i+1]) result[i]=result[i+1];  //   
       }
     
     //   
     if(delta<0)
       {
       if(MA<Line) result[i]=MA;  //   
        else
         {
         //  2      
         if(result[i+2]>MA2) result[i]=MA;  //   
          else result[i]=2.*result[i+1]-result[i+2];  //    
         }
       
       //   
       if(iClose(NULL,tf,i+1)>result[i+1]) result[i]=result[i+1];  //   
       }
     
     }
  
  
//----
  return(0);
}
/*void calculateAngleMA(int tf, int fromBar, int toBar, int maPeriod, int maMethod, int maPrice, double& result[]){
	double MA,MA1,MA2,delta,delta1,Line;
	string s="search from "+fromBar+" to "+toBar+"... gathered: ";
	int idx=0;
	int start=fromBar+maPeriod+5;
	double v[];
	ArrayResize(v,ArraySize(result)+maPeriod+5);
	v[idx]=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,start);
	v[idx+1]=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,start-1);
	v[idx+2]=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,start-2);
	idx=2;
	
	ArrayInitialize(v,0);
	//         (  maPeriod),     
	for(int i=start-3; i>=toBar; i--){
		idx++;
		if(idx>0 && v[idx-1]==0)Print(i+": failed to get proper value");
		MA=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,i);
		MA1=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,i+1);
		MA2=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,i+2);
		//MA3=iMA(NULL,tf,maPeriod,0,maMethod,maPrice,i+3);
		//Print(MA+":"+MA1+":"+MA2);

		delta=MA-MA1;
		delta1=MA1-MA2;
		//delta2=MA2-MA3;

		//   (  ) -    
		if((delta>0 && delta1<=0) || (delta<0 && delta1>=0)){
			v[idx]=MA;
			v[idx+1]=MA1;  //    ( 1- ) !!!!!
			//Print("Saved: "+v[idx]+":"+v[idx+1]);
			continue;
		}

		//     
		Line=2*v[idx+1]-v[idx+2];
		//Line=2*MA1-MA2;

		//   
		if(delta>=0){
			if(MA>Line)v[idx]=MA;  //   
			else{
				//  2      
				if(v[idx+2]<MA2)v[idx]=MA;  //   
				else v[idx]=2.*v[idx+1]-v[idx+2];  //    
			}
			//   
			if(iClose(NULL,tf,i+1)<v[idx+1])v[idx]=v[idx+1];  //   
		}

		//   
		if(delta<0){
			if(MA<Line)v[idx]=MA;  //   
			else{
				//  2      
				if(v[idx+2]>MA2)v[idx]=MA;  //   
				else v[idx]=2.*v[idx+1]-v[idx+2];  //    
			}
			//   
			if(iClose(NULL,tf,i+1)>v[idx+1])v[idx]=v[idx+1];  //   
		}
	}
	for(int y=0; y<11; y++){
		result[y]=v[y+maPeriod+5];
		s=s+"["+y+"]"+result[y]+",";
	}
	Print(s);
}*/